/**
  *  \file server/request.h
  */
#ifndef C2SERVER_SERVER_REQUEST_H
#define C2SERVER_SERVER_REQUEST_H

#include <cstddef>

class Request {
    enum { MAX_LENGTH = 4096 /*16384*/ };  /* FIXME: small for testing */
    std::size_t length;
    std::size_t read_ptr;
    char buffer[MAX_LENGTH];
 public:
    enum State {
        sSuccess,
        sEOF,
        sError,
        sTooLong
    };

    Request();

    char* readLine();
    State readMore(int fd);
    bool shift();
    void clear();
};

#endif
